/*
  Copy 2D Transform
    (C) あかつきみさき(みくちぃP)
    http://sunrisemoon.net/

  このスクリプトについて
    最後に選択したレイヤーの2Dトランスフォームをクリップボードにコピーするスクリプト.
    ・アンカーポイント
    ・位置
    ・スケール
    ・回転
    ・不透明度

  使用方法
    1.ファイル→スクリプト→スクリプトファイルの実行から実行.

  動作環境
    Adobe After Effects CS6以上

  バージョン情報
    2023/08/30 Ver 1.0.0 Release
*/

/// <reference path="D:\lib\aftereffects.d.ts\ae.d.ts"/>

(function () {
    var actComp = app.project.activeItem;
    if (actComp == null || !(actComp instanceof CompItem)) {
        alert("Select Composition", "Copy 2D Transform");
        return 0;
    }

    var selLayers = actComp.selectedLayers;
    if (selLayers.length == 0) {
        alert("Select Layer", "Copy 2D Transform");
        return 0;
    }

    var lastedSelLayer = selLayers[selLayers.length - 1];
    var index = lastedSelLayer.index;

    for (var i = selLayers.length - 1; i >= 0; i--) {
        selLayers[i].selected = false;
    }

    actComp.layer(index).property("ADBE Transform Group").property("ADBE Position").selected = true;
    actComp.layer(index).property("ADBE Transform Group").property("ADBE Anchor Point").selected = true;
    actComp.layer(index).property("ADBE Transform Group").property("ADBE Rotate Z").selected = true;
    if (actComp.layer(index) instanceof AVLayer) {
        actComp.layer(index).property("ADBE Transform Group").property("ADBE Scale").selected = true;
        actComp.layer(index).property("ADBE Transform Group").property("ADBE Opacity").selected = true;
    }

    // コピー
    app.executeCommand(19);
    return 0;
}).call(this);
